@ECHO OFF
if "%~1"=="" GOTO missingparam
set EXE_PATH=%1

echo ******************
echo Installing AMD_Chipset_Drivers from %EXE_PATH%

if "%~2"=="" GOTO nocommands
if "%~2"=="-norebootprompt-noautoreboot" GOTO norebootpromptnoautoreboot
if "%~2"=="-norebootprompt-doautoreboot" GOTO norebootpromptdoautoreboot


:norebootpromptnoautoreboot
START /WAIT "" %EXE_PATH% /S /REBOOTPROMPT=S /REBOOT=ReallySuppress
IF %ERRORLEVEL% EQU 3010 GOTO rebootsuccess
IF %ERRORLEVEL% EQU 0 GOTO checkregistry
GOTO error

:norebootpromptdoautoreboot
START /WAIT "" %EXE_PATH% /S /REBOOTPROMPT=S
IF %ERRORLEVEL% EQU 3010 GOTO rebootsuccess
IF %ERRORLEVEL% EQU 0 GOTO success
GOTO error

:nocommands
START /WAIT "" %EXE_PATH% /S
IF %ERRORLEVEL% EQU 3010 GOTO rebootsuccess
IF %ERRORLEVEL% EQU 0 GOTO success
GOTO error


:missingparam
echo Pass "<path to chipset driver exe>\<chipset driver exe name>" as batch file parameter.
echo This will complete installation in silent mode and prompts user to restart or defer the same when detected.
echo Pass "<path to chipset driver exe>\<chipset driver exe name> -norebootprompt-noautoreboot" as batch file parameter.
echo This will complete installation in silent mode and prints status to command prompt itself.This will suppress UI reboot prompt and automatic system reboot.
echo Pass "<path to chipset driver exe>\<chipset driver exe name> -norebootprompt-doautoreboot" as batch file parameter.
echo This will complete installation in silent mode and automatically reboots the system as and when it is detected without any further intimation to user.
GOTO END

:checkregistry
REG QUERY HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\AMD\AMD_Chipset_Drivers /v REBOOTSTATUS > nul 2> nul
if "%ErrorLevel%"=="0" ( GOTO rebootsuccess ) ELSE ( GOTO success )

:rebootsuccess
echo AMD_Chipset_Drivers Installed Successfully.System needs to be rebooted.
echo ******************
GOTO END

:success
echo AMD_Chipset_Drivers Installed Successfully.No reboot required.
echo ******************
GOTO END

:error
echo AMD_Chipset_Drivers Installation failed with error code %ERRORLEVEL%.
echo ****************** 
GOTO END


:end